from setuptools import find_packages
from skbuild import setup


def readme():
    with open("README.md", "r") as f:
        return f.read()


meta_data = {
    "name": "galpropy",
    "version": "0.0.1",
    "author": "Chen Xia",
    "author_email": "xiachen@itp.ac.cn",
    "maintainer": "Chen Xia",
    "maintainer_email": "xiachen1996@outlook.com",
    "description": "Python wrapper for GALPROPCC",
    "long_description": readme(),
    "long_description_content_type": "text/markdown",
    "keywords": "Cosmic Ray, GALPROPCC",
    "url": "https://code.itp.ac.cn/physcxia/galpropy",
    "project_urls": {"Source Code":
                     "https://code.itp.ac.cn/physcxia/galpropy"},
    "platforms": "Linux",
    "license": "MIT",
    "classifiers": [
        "Programming Language :: Python :: 3 :: Only",
        "Programming Language :: Python :: 3.6",
        "Programming Language :: Python :: 3.7",
        "Programming Language :: Python :: 3.8",
        "Programming Language :: Python :: 3.9",
        "Programming Language :: Python :: 3.10",
        "Programming Language :: C++",
        "License :: OSI Approved :: MIT License",
        "Operating System :: POSIX :: Linux",
        "Topic :: Scientific/Engineering :: Physics",
        "Development Status :: 3 - Alpha",
    ]
}


if __name__ == '__main__':
    setup(**meta_data,
          packages=find_packages(where="src"),
          package_dir={"": "src"},
          python_requires=">=3.6",
          zip_safe=False,
          cmake_install_dir="src/galpropy")
