#include "galpropy.hpp"

void bind_Distribution(py::module_ &m)
{
    py::class_<Dimensions>(m, "Dimensions").def(py::init<>())
        .def("is1", &Dimensions::is1)
        .def("is2", &Dimensions::is2)
        .def("is3", &Dimensions::is3)
        .def("ndim", &Dimensions::ndim)
        .def("npos", &Dimensions::npos);

    py::bind_vector<std::vector<Distribution>>(m, "VecDistribution");
    py::class_<Distribution>(m, "Distribution")
        .def(py::init<>())
        .def("init", py::overload_cast<size_t, size_t, size_t, size_t>
             (&Distribution::init))
        .def("init", py::overload_cast<size_t, size_t, size_t>
             (&Distribution::init))
        .def("init", py::overload_cast<const Dimensions&, size_t>
             (&Distribution::init), "dims"_a, "np"_a=0)
        .def("max", &Distribution::max)
        .def("delete_array", &Distribution::delete_array);
}
