#include <galprop/ParticleLibrary.h>
#include "galpropy.hpp"

void bind_ParticleLibrary(py::module_ &m)
{
    py::class_<ParticleInfo, std::shared_ptr<ParticleInfo>>
        (m, "ParticleInfo")
        .def(py::init<short, short, double, const std::string&>())
        .def_readwrite("name", &ParticleInfo::name)
        .def_readwrite("Ekin", &ParticleInfo::Ekin)
        .def_readwrite("Etot", &ParticleInfo::Etot)
        .def_readwrite("P", &ParticleInfo::P)
        .def_readwrite("Rig", &ParticleInfo::Rig)
        .def_readwrite("gamma", &ParticleInfo::gamma)
        .def_readwrite("beta", &ParticleInfo::beta)
        .def_readwrite("mnuc", &ParticleInfo::mnuc)
        .def_readwrite("mass", &ParticleInfo::mass)
        // .def_readwrite("t_half", &ParticleInfo::t_half) // TODO
        .def_readwrite("beta", &ParticleInfo::beta)
        .def_readwrite("abundance", &ParticleInfo::abundance)
        .def_readwrite("Z", &ParticleInfo::Z)
        .def_readwrite("A", &ParticleInfo::A)
        .def("is_electron", &ParticleInfo::is_electron)
        .def("is_positron", &ParticleInfo::is_positron)
        .def("is_lepton", &ParticleInfo::is_lepton)
        .def("is", &ParticleInfo::is)
        .def("set_ekn", &ParticleInfo::set_ekn);

    py::class_<ParticleLibrary, std::shared_ptr<ParticleLibrary>>
        (m, "ParticleLibrary").def(py::init<>())
        .def("add_record", &ParticleLibrary::add_record)
        .def("get", &ParticleLibrary::get)
        .def("set_ekn", &ParticleLibrary::set_ekn)
        .def("init", &ParticleLibrary::init)
        .def_static("element_name", &ParticleLibrary::element_name)
        .def_static("isotope_name", &ParticleLibrary::isotope_name);
}
