#include <galprop/PropelBase.h>
#include "galpropy.hpp"

class PyPropelBase : PropelBase {
public:
    using PropelBase::PropelBase;
    void propel(Particle& p) override {
        PYBIND11_OVERRIDE_PURE(void, PropelBase, propel, p);
    }
};

class PyPropelOperatorFallback : PropelOperatorFallback {
public:
    using PropelOperatorFallback::PropelOperatorFallback;
    void propel(Particle& p) override {
        PYBIND11_OVERRIDE(void, PropelOperatorFallback, propel, p);
    }
};

void bind_PropelBase(py::module_ &m)
{
    py::class_<PropelBase, PyPropelBase>(m, "PropelBase")
        .def(py::init<const Galdef&>())
        .def("propel", &PropelBase::propel);

    py::class_<PropelOperatorFallback, PyPropelOperatorFallback>(
        m, "PropelOperatorFallback")
        .def(py::init<const Galdef&>())
        .def("propel", &PropelOperatorFallback::propel);

}
