#include <galprop/Spectrum.h>
#include "galpropy.hpp"

void bind_Spectrum(py::module_ &m)
{
    using array_type = std::valarray<double>;
    py::class_<Spectrum>(m, "Spectrum")
        .def(py::init<const std::string&>())
        .def(py::init<const array_type&, const array_type&>(),
             "x"_a, "y"_a=array_type {})
        .def(py::init<const std::vector<double>&,
                      const std::vector<double>&>())
        .def("size", &Spectrum::size)
        .def("save", &Spectrum::save, "Save spectrum",
             "filename"_a="/dev/stdout")
        .def("loginterp", py::overload_cast<double, bool>(
             &Spectrum::loginterp, py::const_), "new_x"_a, "exterp"_a=true)
        .def("loginterp", py::overload_cast<const array_type&, bool>(
             &Spectrum::loginterp, py::const_), "new_x"_a, "exterp"_a=true)
        .def("boost_ekn", &Spectrum::boost_ekn,
             "gb"_a, "mass0"_a, "new_ekn"_a=array_type{})
        .def("scalex", &Spectrum::scalex);
}
